//+------------------------------------------------------------------+
//|                                              Renko indicator.mq4 |
//|                                                           Satori |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Satori"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Navy

extern int       Porog=10;
extern int       BarsCount=0;
extern int       Shift=0;
//---- buffers
double RenkoUPBuff[];
double RenkoDOWNBuff[];
double Monitor[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorDigits(Digits+2);
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,2);
   SetIndexBuffer(0,RenkoDOWNBuff);
   SetIndexEmptyValue(0,0);
   SetIndexLabel(0,"RENKO DOWN");
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,2);
   SetIndexBuffer(1,RenkoUPBuff);
   SetIndexEmptyValue(1,0);
   SetIndexLabel(1,"RENKO UP");
   SetIndexBuffer(2,Monitor);
   SetIndexStyle(2,DRAW_NONE,EMPTY,2);
   SetIndexLabel(2,"Monitor");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,j;
   double Price;
   int    counted_bars=IndicatorCounted();
   counted_bars--;
//----
   if (BarsCount==0) BarsCount=Bars-counted_bars;
    else BarsCount-=counted_bars;
   
   int ac=Digits;
   if (Shift>Porog) Shift=Porog;
   
   for (i=BarsCount; i>=0; i--)
    {
     Price=NormalizeDouble(Close[i],ac);
     //     
     if (RenkoDOWNBuff[i+1]<=0 && RenkoUPBuff[i+1]<=0)
      {
       RenkoDOWNBuff[i]=0;
       RenkoUPBuff[i]=Price-Shift*Point;
       
       continue;
      }
     //----------------------------------------
     //  
     if (RenkoDOWNBuff[i+1]==0 && NormalizeDouble(RenkoUPBuff[i+1]+Porog*Point,ac)>Price && NormalizeDouble(RenkoUPBuff[i+1]-Porog*2*Point,ac)<Price)
      {
       RenkoUPBuff[i]=RenkoUPBuff[i+1];
       RenkoDOWNBuff[i]=0;
//       Monitor[i]=NormalizeDouble(RenkoUPBuff[i+1]-Porog*2*Point,10);
      }
     //----------------------------------------------
     //  
     if (RenkoUPBuff[i+1]==0 && NormalizeDouble(RenkoDOWNBuff[i+1]-Porog*Point,ac)<Price && NormalizeDouble(RenkoDOWNBuff[i+1]+Porog*2*Point,ac)>Price)
      {
       RenkoUPBuff[i]=0;
       RenkoDOWNBuff[i]=RenkoDOWNBuff[i+1];
//       Monitor[i]=NormalizeDouble(RenkoDOWNBuff[i+1]+Porog*2*Point,10);
      }
     //----------------------------------------------

     // 
     if (RenkoDOWNBuff[i+1]==0 && NormalizeDouble(RenkoUPBuff[i+1]+Porog*Point,ac)<=Price)
      {
       for (j=0; j<1000000000; j++)
        {
         if (NormalizeDouble(RenkoUPBuff[i+1]+(Porog*j)*Point,ac)>Price) {j--; break;}
        }
       RenkoUPBuff[i]=RenkoUPBuff[i+1]+(Porog*j)*Point;
       RenkoDOWNBuff[i]=0;
//       Monitor[i]=4;
      }
     //----------------------------------------------
     //----------------------------------------------
    // 
     if (RenkoUPBuff[i+1]==0 && RenkoDOWNBuff[i+1]!=0 && NormalizeDouble(RenkoDOWNBuff[i+1]+Porog*2*Point,ac)<=Price)
      {
       for (j=0; j<1000000000; j++)
        {
         if (NormalizeDouble(RenkoDOWNBuff[i+1]+(Porog*2+Porog*j)*Point,ac)>Price) {j--; break;}
        }
       RenkoUPBuff[i]=RenkoDOWNBuff[i+1]+(Porog*2+Porog*j)*Point;
       RenkoDOWNBuff[i]=0;
//       Monitor[i]=5;
      }
     //----------------------------------------------
     // 
     if (RenkoUPBuff[i+1]==0 && NormalizeDouble(RenkoDOWNBuff[i+1]-Porog*Point,ac)>=Price)
      {
       for (j=0; j<1000000000; j++)
        {
         if (NormalizeDouble(RenkoDOWNBuff[i+1]-(Porog*j)*Point,ac)<Price) {j--; break;}
        }
       RenkoUPBuff[i]=0;
       RenkoDOWNBuff[i]=RenkoDOWNBuff[i+1]-(Porog*j)*Point;
//       Monitor[i]=6;
      }
     //----------------------------------------------
    // 
     if (RenkoDOWNBuff[i+1]==0 && RenkoUPBuff[i+1]!=0 && NormalizeDouble(RenkoUPBuff[i+1]-Porog*2*Point,ac)>=Price)
      {
       for (j=0; j<1000000000; j++)
        {
         if (NormalizeDouble(RenkoUPBuff[i+1]-(Porog*2+Porog*j)*Point,ac)<Price) {j--; break;}
        }
       RenkoUPBuff[i]=0;
       RenkoDOWNBuff[i]=RenkoUPBuff[i+1]-(Porog*2+Porog*j)*Point;
//       Monitor[i]=7;
      }
     // ----------------------------------------------
    if (NormalizeDouble(MathAbs(MathMax(RenkoUPBuff[i],RenkoDOWNBuff[i])-Price),4)>=Porog)
    Print("  ! ",TimeToStr(Time[i]));
    Monitor[i]=MathMax(RenkoUPBuff[i],RenkoDOWNBuff[i]);
    

    }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+